<app-loading *ngIf="isLoading"></app-loading>

<div class="form-setup-assessment">
    <div nz-row [nzGutter]="[30, 10]" class="pb-10">
        <div nz-col nzSpan="6">
            <div class="mb-15">
                <label class="text-bold">
                    {{'targerManager.personalTargetList.label.table.employeeCode' | translate}}
                </label>
            </div>
            <span>{{ currentUser.empCode }}</span>
        </div>
        <div nz-col nzSpan="6">
            <div class="mb-15">
                <label class="text-bold">
                    {{'targerManager.personalTargetList.label.table.fullName' | translate}}
                </label>
            </div>
            <span>{{ currentUser.fullName }}</span>
        </div>
        <div nz-col nzXs="6" nzLg="6">
            <div class="mb-15">
                <label class="text-bold">
                    {{'targerManager.personalTargetList.label.table.periodYear' | translate}}
                </label>
            </div>
            <mb-date-picker [mbMode]="'year'" mbFormat="yyyy"
                mbPlaceholderText="{{'targerManager.personalTargetList.label.table.periodYear' | translate}}"
                                  (ngModelChange)="onChangeSelectYeah($event)" [(ngModel)]="currentYear">
            </mb-date-picker>

        </div>
    </div>
</div>

<div class="data-table-assessment" oncontextmenu="return false;">
    <nz-table #basicTable [nzData]="dataSource" [nzPageSize]="limit" class="data-table" nzSize="small" [nzWidthConfig]="listWidth"
              [nzScroll]="{ x: '1000px', y: '240px' }" [nzShowPagination]="false" nzTableLayout="fixed">
        <thead>
            <tr>
                <th id='index' class="text-center">{{'targerManager.personalTargetList.label.table.stt' | translate}}</th>
                <th id='setOfIndicators'>
                    {{'targerManager.personalTargetList.label.table.setOfIndicators' | translate}}
                </th>
                <th id='position'>{{'targerManager.personalTargetList.label.table.position' | translate}}</th>
                <th scope="col">{{'targerManager.setOfIndicators.label.table.asmFromDate' | translate}}</th>
                <th scope="col">{{'targerManager.setOfIndicators.label.table.asmToDate' | translate}}</th>
                <th id='flagStatus' class="text-center">{{'targerManager.personalTargetList.label.table.flagStatus' | translate}}</th>
                <th id='density'>{{'targerManager.personalTargetList.label.table.density' | translate}} (%)</th>
                <th id='action' nzRight  class="text-center" *ngIf='objFunction?.approve'></th>
            </tr>
        </thead>
        <tbody>
            <tr (dblclick)="redrirectToDetail(data)" class="tr-for-class"
                *ngFor="let data of basicTable.data ; let i = index;">
                <td class="text-center">{{ (pageable?.currentPage - 1) * basicTable.nzPageSize + i + 1 }}
                </td>
                <td>{{ data?.sotName }}</td>
                <td>{{ data?.posName }}</td>
              <td>{{ data?.fromDate | date: 'dd/MM/yyyy'}}</td>
              <td>{{ data?.toDate | date: 'dd/MM/yyyy'}}</td>
              <td class="text-center">
                    <nz-tag [nzColor]="'red'" *ngIf="data.flagStatus === listStatus.CHUA_GUI_XAC_NHAN_GIAO">
                        {{'targerManager.personalTargetList.label.table.notYetSendConfirmAssign' | translate}}
                    </nz-tag>
                    <nz-tag [nzColor]="'blue'" *ngIf="data.flagStatus === listStatus.CHO_XAC_NHAN_GIAO">
                        {{'targerManager.personalTargetList.label.table.waitingSendConfirmAssign' | translate}}
                    </nz-tag>
                    <nz-tag [nzColor]="'blue'" *ngIf="data.flagStatus === listStatus.CHO_PHE_DUYET_GIAO">
                        {{'targerManager.personalTargetList.label.table.waitingApproveAssign' | translate}}
                    </nz-tag>
                    <nz-tag [nzColor]="'blue'" *ngIf="data.flagStatus === listStatus.HOAN_TAT_PHE_DUYET_GIAO">
                        {{'targerManager.personalTargetList.label.table.completedApproveAssign' | translate}}
                    </nz-tag>
                    <nz-tag [nzColor]="'red'" *ngIf="data.flagStatus === listStatus.CHUA_GUI_XAC_NHAN_KET_QUA">
                        {{'targerManager.personalTargetList.label.table.notYetConfirmResult' | translate}}
                    </nz-tag>
                    <nz-tag [nzColor]="'blue'" *ngIf="data.flagStatus === listStatus.CHO_XAC_NHAN_KET_QUA">
                        {{'targerManager.personalTargetList.label.table.waitingConfirmResult' | translate}}
                    </nz-tag>
                    <nz-tag [nzColor]="'blue'" *ngIf="data.flagStatus === listStatus.CHO_PHE_DUYET_KET_QUA">
                        {{'targerManager.personalTargetList.label.table.waitingApproveResult' | translate}}
                    </nz-tag>
                    <nz-tag [nzColor]="'blue'" *ngIf="data.flagStatus === listStatus.HOAN_TAT_PHE_DUYET_KET_QUA">
                        {{'targerManager.personalTargetList.label.table.completedApproveResult' | translate}}
                    </nz-tag>
                </td>
                <td  class="text-right">{{ data?.scaleNum * 100 | formatScore }}</td>
                <td *ngIf='objFunction?.approve' nzRight class="text-center">
                    <ng-container *ngIf="data.flagStatus === listStatus.CHO_XAC_NHAN_GIAO">
                      <div nz-row [nzGutter]="[8, 8]">
                        <div nz-col [nzXl]="{ span: 24 }" [nzXXl]="{ span: 12 }">
                          <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="updateStatus(data, $event)"
                                     mbButtonText="{{'targerManager.table.action.yes' | translate}}" mbButtonAvailableStyle="PRIMARY"></mb-button>
                        </div>
                        <div nz-col [nzXl]="{ span: 24 }" [nzXXl]="{ span: 12 }">
                          <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="showRejectDialog(data, $event)"
                                     mbButtonText="{{'targerManager.table.action.no' | translate}}" mbButtonAvailableStyle="PRIMARY"></mb-button>
                        </div>
                      </div>
                    </ng-container>
                </td>
            </tr>
        </tbody>
    </nz-table>
</div>


<nz-modal [(nzVisible)]="isVisibleRejectDialog" [nzTitle]="modalTitle" [nzContent]="modalContent"
    [nzFooter]="modalFooter" [nzWidth]="500" (nzOnCancel)="cancelRejectDialog()">
    <ng-template #modalTitle>{{'targerManager.personalTargetList.label.table.reject' | translate}}</ng-template>

    <ng-template #modalContent>
        <form nz-form [formGroup]="formReject">
            <div nz-col nzXs="24" nzLg="24">
                <mb-input-text formControlName="reason" [mbIsTextAre]="true"
                    [mbType]="isSubmitted &&formReject.dirty && (formReject.controls['reason'].errors || formReject.errors?.noAllowSpace) ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && formReject.dirty && (formReject.controls['reason'].errors || formReject.errors?.noAllowSpace) !== null"
                    [mbErrors]="formReject.controls['reason'].errors" [mbErrorDefs]="[
                    { errorName: 'maxlength', errorDescription: 'goaManagement.validate.maxLength' | translate: {'numberLength': '250' }},
                    { errorName: 'required', errorDescription: 'goaManagement.validate.required' | translate: {'param': 'targerManager.personalTargetList.label.table.reasonReject' | translate }},
                    { errorName: 'noAllowSpace', errorDescription: 'goaManagement.validate.required' | translate: {'param': 'targerManager.personalTargetList.label.table.reasonReject' | translate }},
                    { errorName: 'reason', errorDescription: 'goaManagement.validate.code' | translate }]"
                    mbPlaceholderText="{{'targerManager.personalTargetList.label.table.inputReasonReject' | translate}}"
                    mbLabelText="{{'targerManager.personalTargetList.label.table.reasonReject' | translate}} <span class='label__required'>*</span>">
                </mb-input-text>
            </div>
        </form>
    </ng-template>

    <ng-template #modalFooter>
        <button nz-button nzType="primary" (click)="acceptRejectDialog()" [nzLoading]="isConfirmLoadingRejectDialog">
            {{'common.button.continue' | translate}}
        </button>
        <button nz-button nzType="default" (click)="cancelRejectDialog()">
            {{'common.button.cancel' | translate}}
        </button>
    </ng-template>
</nz-modal>
